/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/accessories/CurrencyFormatter.as
 * org.apache.royale.html.accessories.CurrencyFormatter
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.accessories.CurrencyFormatter');

goog.require('org.apache.royale.core.IBeadModel');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.core.IFormatBead');
goog.require('org.apache.royale.utils.Language');



/**
 *  constructor
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {org.apache.royale.core.IFormatBead}
 */
org.apache.royale.html.accessories.CurrencyFormatter = function() {
  org.apache.royale.html.accessories.CurrencyFormatter.base(this, 'constructor');
};
goog.inherits(org.apache.royale.html.accessories.CurrencyFormatter, org.apache.royale.events.EventDispatcher);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.html.accessories.CurrencyFormatter', org.apache.royale.html.accessories.CurrencyFormatter);


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype._strand;


/**
 * @asprivate
 * @private
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype.handleBeadsAdded = function(event) {
  var /** @type {org.apache.royale.core.IBeadModel} */ model = org.apache.royale.utils.Language.as(this._strand.getBeadByType(org.apache.royale.core.IBeadModel), org.apache.royale.core.IBeadModel);
  model.addEventListener(this.eventName, org.apache.royale.utils.Language.closure(this.propertyChangeHandler, this, 'propertyChangeHandler'));
  model.addEventListener(this.propertyName + "Change", org.apache.royale.utils.Language.closure(this.propertyChangeHandler, this, 'propertyChangeHandler'));
  this.propertyChangeHandler(null);
};


/**
 * @private
 * @type {string}
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype._propertyName;


/**
 * @private
 * @type {string}
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype._eventName;


/**
 * @private
 * @type {string}
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype._formattedResult;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype._fractionalDigits = 2;


/**
 * @private
 * @type {string}
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype._currencySymbol = "$";


/**
 * @asprivate
 * @private
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype.propertyChangeHandler = function(event) {
  var /** @type {org.apache.royale.core.IBeadModel} */ model = org.apache.royale.utils.Language.as(this._strand.getBeadByType(org.apache.royale.core.IBeadModel), org.apache.royale.core.IBeadModel);
  var /** @type {Object} */ value = model[this.propertyName];
  this._formattedResult = this.format(value);
  var /** @type {org.apache.royale.events.Event} */ newEvent = new org.apache.royale.events.Event("formatChanged");
  this.dispatchEvent(newEvent);
};


/**
 *  Computes the formatted string.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @export
 * @param {Object} value
 * @return {string}
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype.format = function(value) {
  if (value == null)
    return "";
  var /** @type {number} */ num = Number(value);
  var /** @type {string} */ source = num.toFixed(this.fractionalDigits);
  return this.currencySymbol + source;
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__strand = function(value) {
  this._strand = value;
  org.apache.royale.utils.Language.as(value, org.apache.royale.events.IEventDispatcher, true).addEventListener("beadsAdded", org.apache.royale.utils.Language.closure(this.handleBeadsAdded, this, 'handleBeadsAdded'));
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__propertyName = function() {
  if (this._propertyName == null) {
    return "text";
  }
  return this._propertyName;
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__propertyName = function(value) {
  this._propertyName = value;
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__eventName = function() {
  if (this._eventName == null) {
    return this._propertyName + "Changed";
  }
  return this._eventName;
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__eventName = function(value) {
  this._eventName = value;
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__fractionalDigits = function() {
  return this._fractionalDigits;
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__fractionalDigits = function(value) {
  this._fractionalDigits = value;
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__currencySymbol = function() {
  return this._currencySymbol;
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__currencySymbol = function(value) {
  this._currencySymbol = value;
};


org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__formattedString = function() {
  return this._formattedResult;
};


Object.defineProperties(org.apache.royale.html.accessories.CurrencyFormatter.prototype, /** @lends {org.apache.royale.html.accessories.CurrencyFormatter.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__strand},
/**
  * @export
  * @type {string} */
propertyName: {
get: org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__propertyName,
set: org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__propertyName},
/**
  * @export
  * @type {string} */
eventName: {
get: org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__eventName,
set: org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__eventName},
/**
  * @export
  * @type {number} */
fractionalDigits: {
get: org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__fractionalDigits,
set: org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__fractionalDigits},
/**
  * @export
  * @type {string} */
currencySymbol: {
get: org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__currencySymbol,
set: org.apache.royale.html.accessories.CurrencyFormatter.prototype.set__currencySymbol},
/**
  * @export
  * @type {string} */
formattedString: {
get: org.apache.royale.html.accessories.CurrencyFormatter.prototype.get__formattedString}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CurrencyFormatter', qName: 'org.apache.royale.html.accessories.CurrencyFormatter', kind: 'class' }], interfaces: [org.apache.royale.core.IFormatBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.accessories.CurrencyFormatter.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.html.accessories.CurrencyFormatter'},
        'propertyName': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.html.accessories.CurrencyFormatter'},
        'eventName': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.html.accessories.CurrencyFormatter'},
        'fractionalDigits': { type: 'int', access: 'readwrite', declaredBy: 'org.apache.royale.html.accessories.CurrencyFormatter'},
        'currencySymbol': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.html.accessories.CurrencyFormatter'},
        'formattedString': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.html.accessories.CurrencyFormatter'}
      };
    },
    methods: function () {
      return {
        'CurrencyFormatter': { type: '', declaredBy: 'org.apache.royale.html.accessories.CurrencyFormatter'},
        'format': { type: 'String', declaredBy: 'org.apache.royale.html.accessories.CurrencyFormatter', parameters: function () { return [  { index: 1, type: 'Object', optional: false } ]; }}
      };
    }
  };
};