/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/accessories/NumberFormatter.as
 * org.apache.royale.html.accessories.NumberFormatter
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.accessories.NumberFormatter');

goog.require('org.apache.royale.core.IBeadModel');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.core.IFormatBead');
goog.require('org.apache.royale.utils.Language');



/**
 *  constructor
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {org.apache.royale.core.IFormatBead}
 */
org.apache.royale.html.accessories.NumberFormatter = function() {
  org.apache.royale.html.accessories.NumberFormatter.base(this, 'constructor');
};
goog.inherits(org.apache.royale.html.accessories.NumberFormatter, org.apache.royale.events.EventDispatcher);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.html.accessories.NumberFormatter', org.apache.royale.html.accessories.NumberFormatter);


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.html.accessories.NumberFormatter.prototype._strand;


/**
 * @asprivate
 * @private
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.html.accessories.NumberFormatter.prototype.handleBeadsAdded = function(event) {
  var /** @type {org.apache.royale.core.IBeadModel} */ model = org.apache.royale.utils.Language.as(this._strand.getBeadByType(org.apache.royale.core.IBeadModel), org.apache.royale.core.IBeadModel);
  model.addEventListener(this.eventName, org.apache.royale.utils.Language.closure(this.propertyChangeHandler, this, 'propertyChangeHandler'));
  model.addEventListener(this.propertyName + "Change", org.apache.royale.utils.Language.closure(this.propertyChangeHandler, this, 'propertyChangeHandler'));
  this.propertyChangeHandler(null);
};


/**
 * @private
 * @type {string}
 */
org.apache.royale.html.accessories.NumberFormatter.prototype._propertyName;


/**
 * @private
 * @type {string}
 */
org.apache.royale.html.accessories.NumberFormatter.prototype._eventName;


/**
 * @private
 * @type {string}
 */
org.apache.royale.html.accessories.NumberFormatter.prototype._formattedResult;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.accessories.NumberFormatter.prototype._groupSize = 3;


/**
 * @private
 * @type {string}
 */
org.apache.royale.html.accessories.NumberFormatter.prototype._thousandsSeparator = ",";


/**
 * @asprivate
 * @private
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.html.accessories.NumberFormatter.prototype.propertyChangeHandler = function(event) {
  var /** @type {org.apache.royale.core.IBeadModel} */ model = org.apache.royale.utils.Language.as(this._strand.getBeadByType(org.apache.royale.core.IBeadModel), org.apache.royale.core.IBeadModel);
  var /** @type {Object} */ value = model[this.propertyName];
  this._formattedResult = this.format(value);
  var /** @type {org.apache.royale.events.Event} */ newEvent = new org.apache.royale.events.Event("formatChanged");
  this.dispatchEvent(newEvent);
};


/**
 * @asprivate
 * @private
 * @param {Object} value
 * @return {string}
 */
org.apache.royale.html.accessories.NumberFormatter.prototype.format = function(value) {
  if (value == null)
    return "";
  var /** @type {number} */ num = Number(value);
  var /** @type {string} */ source = String(value);
  var /** @type {Array} */ parts = source.split(this.thousandsSeparator);
  source = parts.join("");
  var /** @type {number} */ l = source.length;
  var /** @type {string} */ result = "";
  var /** @type {number} */ group = 0;
  for (var /** @type {number} */ i = l - 1; i >= 0; i--) {
    if (group == this._groupSize && result.length > 0) {
      result = this.thousandsSeparator + result;
      group = 0;
    }
    result = source.charAt(i) + result;
    group++;
  }
  return result;
};


org.apache.royale.html.accessories.NumberFormatter.prototype.set__strand = function(value) {
  this._strand = value;
  org.apache.royale.utils.Language.as(value, org.apache.royale.events.IEventDispatcher, true).addEventListener("beadsAdded", org.apache.royale.utils.Language.closure(this.handleBeadsAdded, this, 'handleBeadsAdded'));
};


org.apache.royale.html.accessories.NumberFormatter.prototype.get__propertyName = function() {
  if (this._propertyName == null) {
    return "text";
  }
  return this._propertyName;
};


org.apache.royale.html.accessories.NumberFormatter.prototype.set__propertyName = function(value) {
  this._propertyName = value;
};


org.apache.royale.html.accessories.NumberFormatter.prototype.get__eventName = function() {
  if (this._eventName == null) {
    return this._propertyName + "Changed";
  }
  return this._eventName;
};


org.apache.royale.html.accessories.NumberFormatter.prototype.set__eventName = function(value) {
  this._eventName = value;
};


org.apache.royale.html.accessories.NumberFormatter.prototype.get__thousandsSeparator = function() {
  return this._thousandsSeparator;
};


org.apache.royale.html.accessories.NumberFormatter.prototype.set__thousandsSeparator = function(value) {
  this._thousandsSeparator = value;
};


org.apache.royale.html.accessories.NumberFormatter.prototype.get__formattedString = function() {
  return this._formattedResult;
};


Object.defineProperties(org.apache.royale.html.accessories.NumberFormatter.prototype, /** @lends {org.apache.royale.html.accessories.NumberFormatter.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.html.accessories.NumberFormatter.prototype.set__strand},
/**
  * @export
  * @type {string} */
propertyName: {
get: org.apache.royale.html.accessories.NumberFormatter.prototype.get__propertyName,
set: org.apache.royale.html.accessories.NumberFormatter.prototype.set__propertyName},
/**
  * @export
  * @type {string} */
eventName: {
get: org.apache.royale.html.accessories.NumberFormatter.prototype.get__eventName,
set: org.apache.royale.html.accessories.NumberFormatter.prototype.set__eventName},
/**
  * @export
  * @type {string} */
thousandsSeparator: {
get: org.apache.royale.html.accessories.NumberFormatter.prototype.get__thousandsSeparator,
set: org.apache.royale.html.accessories.NumberFormatter.prototype.set__thousandsSeparator},
/**
  * @export
  * @type {string} */
formattedString: {
get: org.apache.royale.html.accessories.NumberFormatter.prototype.get__formattedString}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.accessories.NumberFormatter.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'NumberFormatter', qName: 'org.apache.royale.html.accessories.NumberFormatter', kind: 'class' }], interfaces: [org.apache.royale.core.IFormatBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.accessories.NumberFormatter.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.html.accessories.NumberFormatter'},
        'propertyName': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.html.accessories.NumberFormatter'},
        'eventName': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.html.accessories.NumberFormatter'},
        'thousandsSeparator': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.html.accessories.NumberFormatter'},
        'formattedString': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.html.accessories.NumberFormatter'}
      };
    },
    methods: function () {
      return {
        'NumberFormatter': { type: '', declaredBy: 'org.apache.royale.html.accessories.NumberFormatter'}
      };
    }
  };
};